ACM-ICPC 2018 南京赛区网络预赛 L. Magical Girl Haze(分层dijkstra)

题意:有n个地方,m条带权值的路,你有k次机会将一条路的权值变为0,求1到n的最短距离。

分析:这是一题分层dijkstra的模板题,因为k的大小不是很大,最坏的情况也就是10,而我们一般的最短路问题只是建一个平面的图。

而分层dijkstra是一个空间的。怎么操作呢?

举个简单的栗子

当数据如下是

n  m  k

3  2  1

1  2  5(路的起点1,终点2,权值5)

2  3  6

没有k的情况就是这样的

如果有k的情况,即1到2权值可能为0,2到3也可能为0,我们可以加一个平面表示他们的关系

将4,5,6(地方)表示1,2,3的关系图形如下:(图很丑,将就着看。。。)

为什么这样表示呢?   因为我们可能理解1到2可能变成0,所以1到5的距离为0,2到3可能变为0即2到6距离为0.

答案就是1到3的最短路与1到6的最短路最小值。

我们可以通过这样一个简单的例子来理解:

1.k的大小关系到分的层数(k+1层)。

2.只有层与层之间的路才为0,这样使用的k值就不会超过给定的。

3.而答案可能没用到k,那答案就是1到n的最短路,如果用一次就是1到2*n的最短路,如果用k次就是1到(k+1)*n的最短路

所以答案就是min(d[n],d[n*2]....d[(k+1)*n])  (d[]表示1到其的距离)。

这个方法很巧妙地避免了使用k的问题。只要先建好图,直接用dijkstra.

这里还要注意几个问题:

1.图的存储方式,m的范围有点大,不能用邻接矩阵,这里用的是链式前向星,邻接表也可以。

2.数组的大小,因为图最坏是11层(最坏11*m),层与层之间也有路(最坏10*m),所以最少要开21*m的数组

3.这里用了优先队列,防止时间超时。(不知道不用会不会超时,没试过)。

代码:

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<queue>
#define inf 0x3f3f3f3f
using namespace std;
typedef long long ll;
const ll maxn=3e6+10;
struct node{
    ll from,to;
    ll next;
    ll w;//权值
}edge[2*maxn];//前向星
struct point{
    ll y,val;
}t,p;
ll head[maxn],visit[maxn],d[maxn];
ll ans,cnt,k,n,m;
bool operator < (point a,point b)//优先路径短的
{
    if(a.val==b.val)
        return a.y<b.y;
    return a.val>b.val;
}
priority_queue<point> q;

void init()
{
    memset(head,-1,sizeof(head));
    memset(visit,0,sizeof(visit));
    memset(d,0x3f,sizeof(d));
    cnt=0;
}

void add(ll u,ll v,ll w)//前向星加边
{
    edge[cnt].from=u;
    edge[cnt].to=v;
    edge[cnt].w=w;
    edge[cnt].next=head[u];
    head[u]=cnt++;
}

void dijkstra(int u,int v)//dijkstra
{
    d[u]=0;
    t.y=u,t.val=0;
    q.push(t);
    while(!q.empty())
    {
        p=q.top();
        q.pop();
        if(visit[p.y])
            continue;
        visit[p.y]=1;
        for(int i=head[p.y];i!=-1;i=edge[i].next)
        {
            int e=edge[i].to;
            //cout<<e<<endl;
            if(d[e]>d[p.y]+edge[i].w)
            {
                d[e]=d[p.y]+edge[i].w;
                t.y=e,t.val=d[e];
                q.push(t);
            }
        }
    }
    ans=inf;
    for(int i=0;i<=k;i++)//取d[n],d[n*2]...d[(k+1)*n]最小
    {
        if(ans>d[v+i*n])
            ans=d[v+i*n];
    }
    cout<<ans<<endl;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        init();
        scanf("%lld%lld%lld",&n,&m,&k);
        if(k>=m)//k大于边数,无疑答案是0
        {
            cout<<0<<endl;
            continue;
        }
        for(int i=1;i<=m;i++)
        {
            ll u,v,w;
            scanf("%lld%lld%lld",&u,&v,&w);
            for(int j=0;j<=k;j++)
            {
                add(u+j*n,v+j*n,w);//每一层地方的关系,建图
                if(j!=k)
                    add(u+j*n,v+(j+1)*n,0);//层与层之间的关系,建图
            }
        }
        dijkstra(1,n);
    }
    return 0;
}

原文地址:https://www.cnblogs.com/xiongtao/p/9642152.html

时间: 2024-11-09 10:03:38

ACM-ICPC 2018 南京赛区网络预赛 L. Magical Girl Haze(分层dijkstra)的相关文章

ACM-ICPC 2018 南京赛区网络预赛 L. Magical Girl Haze

262144K There are NN cities in the country, and MM directional roads from uu to v(1\le u, v\le n)v(1≤u,v≤n). Every road has a distance c_ici?. Haze is a Magical Girl that lives in City 11, she can choose no more than KK roads and make their distances

ACM-ICPC 2018 南京赛区网络预赛 L题(分层最短路)

题目链接:https://nanti.jisuanke.com/t/31001 题目大意:给出一个含有n个点m条边的带权有向图,求1号顶点到n号顶点的最短路,可以使<=k条任意边的权值变为0. 样例输入 复制 1 5 6 1 1 2 2 1 3 4 2 4 3 3 4 1 3 5 6 4 5 2 样例输出 复制 3 解题思路:可以用两种做法,不过都差不多,应该算是同一种思路的不同写法.第一种是在建图时,将一个点拆成k个层次的点,应该总共有k+1层,每个相同层次的点按输入的边权连接,每个点可以向它

ACM-ICPC 2018 南京赛区网络预赛 Lpl and Energy-saving Lamps 线段树

目录 ACM-ICPC 2018 南京赛区网络预赛 Lpl and Energy-saving Lamps 线段树 题面 题意 思路 ACM-ICPC 2018 南京赛区网络预赛 Lpl and Energy-saving Lamps 线段树 题面 During tea-drinking, princess, amongst other things, asked why has such a good-natured and cute Dragon imprisoned Lpl in the

ACM-ICPC 2018 南京赛区网络预赛 E题

ACM-ICPC 2018 南京赛区网络预赛 E题 题目链接: https://nanti.jisuanke.com/t/30994 Dlsj is competing in a contest with n (0 < n \le 20)n(0<n≤20) problems. And he knows the answer of all of these problems. However, he can submit ii-th problem if and only if he has s

ACM-ICPC 2018 南京赛区网络预赛 J.Sum

Sum A square-free integer is an integer which is indivisible by any square number except 11. For example, 6 = 2 \cdot 36=2⋅3 is square-free, but 12 = 2^2 \cdot 312=22⋅3 is not, because 2^222 is a square number. Some integers could be decomposed into

计蒜客 ACM-ICPC 2018 南京赛区网络预赛 A. An Olympian Math Problem-数学公式题

A. An Olympian Math Problem 54.28% 1000ms 65536K Alice, a student of grade 66, is thinking about an Olympian Math problem, but she feels so despair that she cries. And her classmate, Bob, has no idea about the problem. Thus he wants you to help him.

ACM-ICPC 2018 焦作赛区网络预赛 L 题 Poor God Water

God Water likes to eat meat, fish and chocolate very much, but unfortunately, the doctor tells him that some sequence of eating will make them poisonous. Every hour, God Water will eat one kind of food among meat, fish and chocolate. If there are 33 

ACM-ICPC 2018 南京赛区网络预赛

A An Olympian Math Problem #include <bits/stdc++.h> using namespace std; typedef long long ll; ll T,n; int main(){ scanf("%lld",&T); while(T--){ scanf("%lld",&n); printf("%lld\n",n-1); } } B The writing on the w

ACM-ICPC 2018 南京赛区网络预赛 做题记录

比赛的时候被J题卡常然后B题自闭最后G题没调完 5题gg 现在补题进度:6/12 A. 题解: 高考数学题,裂项完之后答案就是n!-1 (n!)%n=0,所以就是n-1 1 #include<bits/stdc++.h> 2 #define ll long long 3 using namespace std; 4 int T; 5 ll n; 6 int main() 7 { 8 cin>>T; 9 while(T--) 10 { 11 cin>>n; 12 cout